#ifndef __PKT_QWK_H
#define __PKT_QWK_H

#include "pkt_obj.h"

typedef struct {
    long pos;
    char conf;
} NDX_REC;

typedef struct {
    char flag;
    char num[7];
    char date[8];
    char time[5];
    char mto[25];
    char mfrom[25];
    char subj[25];
    char passw[12];
    char reply[8];
    char blocks[6];
    char active;
    unsigned short conf;
    unsigned short null;
    char network;
} msg_header;

class qwk_packet:public offline_packet {
    char whoto[26];

    /* For .NDX files */
    FILE *Fndx;
    NDX_REC *ndxarr;
    unsigned ndxopen;

    char remove_replyfile;

    void put_file(char *name);
    char *get_qwk_str(char *str, char size);

    void read_txt(unsigned long num);
    long read_idx(unsigned num);

public:
    char open_packet(char *str);
    void close_packet(void);

    char read_msg(unsigned msgnum);

    long read_num(unsigned msgnum);
    char *read_from(unsigned msgnum);
    char *read_to(unsigned msgnum);
    char *read_subj(unsigned msgnum);

    char *export_msg(char *out);
    /*char init_text(void);
    char *read_line(char *str, unsigned line);*/

    void open_replypacket(void);
    void close_replypacket(void);

    void write_arealist(FILE *F);
};

#endif
